CREATE OR REPLACE FUNCTION DES_ISS_BH_E(
   P_CDEMPRESA      IN NOTAFISCAL.CDEMPRESA%TYPE,
   P_CDINSCMUNI     IN NOTAFISCAL.CDINSCMUNI%TYPE,
   P_DTINICIAL      IN NOTAFISCAL.DTEMISSAO%TYPE,
   P_DTFINAL        IN NOTAFISCAL.DTEMISSAO%TYPE,
   P_VERSAO         VARCHAR2,
   P_NRSEQARQMAG    IN ARQMAGNETICO.NRSEQARQMAG%TYPE,
   P_CDIMPOSTO      IN VARCHAR2,
   P_NRINSJUREMPR   IN VARCHAR2) RETURN NUMBER
AS
   V_REG_E          NUMBER;
   V_CONTREGA       NUMBER;
   V_ISSQN_S        VARCHAR2(2);
   V_ISSQN_RET_S    VARCHAR2(2);
   V_CDSITUCRT      VARCHAR2(1);

BEGIN
   V_ISSQN_S     := '31';
   V_ISSQN_RET_S := '36';
   V_CONTREGA    := 0;
   BEGIN
      SELECT NVL(MAX(CDSITUCRT), '3') AS CDSITUCRT
        INTO V_CDSITUCRT
        FROM PARAMEMPRESA
       WHERE CDEMPRESA = P_CDEMPRESA;
   EXCEPTION
      WHEN NO_DATA_FOUND THEN
           V_CDSITUCRT := '3';
   END;
   /*GERA REGISTRO ISS SERVIOS PRESTADOS (TIPO - E) */
   FOR C_ISS_E IN (SELECT  'E'                                                                               ||'|'||   /*TIPO*/
                           TO_CHAR(DTEMISSAO,'ddmmyyyy')                                                     ||'|'||   /*DATA DE EMISSAO*/
                           CODTRIB                                                                           ||'|'||   /*CODIGO DE TRIBUTACAO*/
                           REPLACE(REPLACE(REPLACE(INSCMUNI,'-',''),'/',''),'.','')                          ||'|'||   /*INSCRICAO MUNICIPAL*/
                           CDMODDOCFISC                                                                      ||'|'||   /*MODELO DE DOCUMENTO DES*/
                           SERIE                                                                             ||'|'||   /*SERIE DES*/
                           SUBSERIE                                                                          ||'|'||   /*SUBSERIE*/
                           TPNGOC                                                                            ||'|'||   /*TIPO DO NEGCIO*/
                           EXIGEISSQN                                                                        ||'|'||   /*EXIGENCIA DE ISSQN*/
                           MUNICIPIOIBGE                                                                     ||'|'||   /*MUNICIPIO IBGE*/
                           REG_ESP_TRIB                                                                      ||'|'||   /*REGIME ESPECIAL DE TRIBUTAO*/
                           DECODE(VR_RET, 0, '2', '1')                                                       ||'|'||   /*VALOR RETIDO*/
                           NUM_DOC                                                                           ||'|'||   /*NUMERO DOCUMENTO*/
                           NUM_DOC                                                                           ||'|'||   /*NUMERO FINAL*/
                           LTRIM(TO_CHAR(VRNOTAFISC, '999999990.00'))                                        ||'|'||   /*VALOR DA NOTA*/
                           LTRIM(TO_CHAR(VRPRODUTOS, '999999990.00'))                                        ||'|'||   /*VALOR DOS SERVICOS*/
                           LTRIM(TO_CHAR(ALIQUOTA, '9990.00'))                                               ||'|'||   /*ALIQUOTA*/
                           SITU_DOCU                                                                         ||'|'||   /*SITUACAO DO DOCUMENTO*/
                           SIMPLES_NAC                                                                       ||'|'||   /*SIMPLES NACIONAL*/
                           INSC_TOMAD                                                                        ||'|'||   /*INSCRICAO MUNICIPAL TOMADOR*/
                           REPLACE(REPLACE(REPLACE(CNPJ,'-',''),'/',''),'.','')                              ||'|'||   /*INSCRICAO JURIDICA*/
                           REPLACE(REPLACE(REPLACE(CPF,'-',''),'/',''),'.','')                               ||'|'||   /*CPF*/
                           RAZSOC                                                                            ||'|'||   /*RAZAO SOCIAL*/
                           LOGRADOURO                                                                        ||'|'||   /*ENDERECO*/
                           TRIM(NUMERO)                                                                      ||'|'||   /*NUMERO*/
                           TRIM(COMPLEMENTO)                                                                 ||'|'||   /*COMPLEMENTO*/
                           TRIM(BAIRRO)                                                                      ||'|'||   /*BAIRRO*/
                           TRIM(MUNICIPTOM)                                                                  ||'|'||   /*MUNICIPO DO TOMADOR*/
                           TRIM(PAISTOM)                                                                     ||'|'||   /*PAIS DO TOMADOR*/
                           TRIM(CEP_TOM)                                                                     ||'|'||   /*CEP DO TOMADOR*/
                           TRIM(TEL_TOM)                                                                     ||'|'||   /*TELEFONE DO TOMADOR*/
                           TRIM(EMAIL_TOM)                                                                   ||'|'||   /*EMAIL DO TOMADOR*/
                           INS_MUNI_TERC                                                                     ||'|'||   /*INSCRICAO DE TERCEIROS*/
                           CNPJ_TERC                                                                         ||'|'||   /*INSCRICAO JURIDICA DE TERCEIROS*/
                           CPF_TERC                                                                          ||'|'||   /*CPF DE TERCEIROS*/
                           RAZ_SOC_TERC                                                                      ||'|'||   /*RAZAO SOCIAL DE TERCEIROS*/
                           LOGR_TERC                                                                         ||'|'||   /*LOGRADOURO DE TERCEIROS*/
                           NUM_TERC                                                                          ||'|'||   /*NUMERO DE TERCEIROS*/
                           COMP_END_TERC                                                                     ||'|'||   /*COMPLEMENTO DE TERCEIROS*/
                           BAI_TERC                                                                          ||'|'||   /*BAIRRO DE TERCEIROS*/
                           MUNIC_TERC                                                                        ||'|'||   /*MUNICIPIO DD TERCEIROS*/
                           PAIS_TERC                                                                         ||'|'||   /*PAIS DE TERCEIROS*/
                           CEP_TERC                                                                          ||'|'||   /*CEP DE TERCEIROS*/
                           TEL_TERC                                                                          ||'|'||   /*TELEFONE DE TERCEIROS*/
                           EMAIL_TERC                                                                        ||'|'||   /*EMAIL DE TERCEIROS*/
                           MUNIC_PREST                                                                       ||'|'||   /*MUNICIPIO DO PRESTADOR*/
                           PAIS_PREST                                                                        ||'|'||   /*PAIS PRESTADOR*/
                           DESC_EVEN                                                                         ||'|'||   /*DESCRICAO DO EVENTO*/
                           DT_EVEN                                                                           ||'|'||   /*DATA DO EVENTO*/
                           DT_COMP_SERV                                                                      ||'|'||   /*DATA DE COMPETENCIA*/
                           DT_CANC_NF                                                                        ||'|'||   /*DATA DE CANCELAMENTO*/
                           MOT_CANC                                                                          ||'|'||   /*MOTICO DO CANCELAMENTO*/
                           DS_CANC                                                                           ||'|'||   /*DESCRIO DO CANCELAMENTO*/
                           NUM_NF_SUBS                                                                       ||'|'  AS REG_ISS_E   /*NUMERO DA NF SUBSTITUIDORA*/
                     FROM (SELECT NF.DTEMISSAO,
                                  CLASSE_CODTRIBPROD(PR.CDARVPROD,NF.CDEMPRESA, NF.CDINSCMUNI) AS CODTRIB,
                                  NF.CDINSCMUNI AS INSCMUNI ,
                                  MO.CDMODDOCFISC,
                                  DES_ISS_SERIE(P_CDEMPRESA, P_CDINSCMUNI, NF.CDSERIE) AS SERIE,
                                  '' AS SUBSERIE,
                                  '' AS TPNGOC,
                                  PSE.IDEXIGISSQN AS EXIGEISSQN,
                                  MU.CDMUNICIBGE AS MUNICIPIOIBGE,
                                  DECODE(NF.IDSTATUS,'C', '0', DES_ISS_REG_ESP_TRIBUT(P_CDEMPRESA, P_CDINSCMUNI)) AS  REG_ESP_TRIB,
                                  SUM(NVL(DECODE(II.CDIMPOSTONFE,V_ISSQN_RET_S,DECODE(IT.CDFISCALIT,'1',IT.VRIMPOSTOIT,0),0),0)) AS VR_RET,
                                  NF.NRNOTAFISC AS NUM_DOC,
                                  NF.VRNOTAFISC,
                                  NF.VRPRODUTOS,
                                  DECODE(IT.CDFISCALIT, '1', IT.VRALIQITEM , 0) AS ALIQUOTA,
                                  DECODE(NF.IDSTATUS,'A','1','C','2','3') AS SITU_DOCU,
                                  DECODE(V_CDSITUCRT, '3', '2',DECODE(DES_ISS_REG_ESP_TRIBUT(P_CDEMPRESA, P_CDINSCMUNI),'9','1','10','3','2')) AS SIMPLES_NAC ,
                                  DECODE(MU.CDMUNICIBGE, '3106200', NF.CDINSCMUNI, '') AS INSC_TOMAD,
                                  DECODE(LENGTH(REPLACE(REPLACE(REPLACE(CL.NRINSJURCLIE,'-',''),'/',''),'.','')),14,CL.NRINSJURCLIE,' ') AS CNPJ,
                                  DECODE(LENGTH(REPLACE(REPLACE(REPLACE(CL.NRINSJURCLIE,'-',''),'/',''),'.','')),11,CL.NRINSJURCLIE,' ') AS CPF,
                                  NVL(CL.NMRAZSOCCLIE,'DIVERSOS') AS RAZSOC,
                                  ED.DSENDECLIE AS LOGRADOURO,
                                  '' AS NUMERO,
                                  ED.DSCOMPENDCLI AS COMPLEMENTO,
                                  ED.NMBAIRCLIE AS BAIRRO,
                                  MU.CDMUNICIBGE AS MUNICIPTOM,
                                  PS.CDPAISBACEN AS PAISTOM,
                                  DECODE(PS.CDPAISBACEN, '1058', ED.NRCEPCLIE, '' ) AS CEP_TOM,
                                  ED.NRTELECLIE AS TEL_TOM,
                                  ED.DSEMAILCLIE AS EMAIL_TOM,
                                  '' AS INS_MUNI_TERC,
                                  '' AS CNPJ_TERC,
                                  '' AS CPF_TERC,
                                  '' AS RAZ_SOC_TERC,
                                  '' AS LOGR_TERC,
                                  '' AS NUM_TERC,
                                  '' AS COMP_END_TERC,
                                  '' AS BAI_TERC,
                                  '' AS MUNIC_TERC,
                                  '' AS PAIS_TERC,
                                  '' AS CEP_TERC,
                                  '' AS TEL_TERC,
                                  '' AS EMAIL_TERC,
                                  '' AS MUNIC_PREST,
                                  DECODE(PS.CDPAISBACEN, '1058', ED.NRCEPCLIE, '' ) AS PAIS_PREST,
                                  '' AS DESC_EVEN,
                                  '' AS DT_EVEN,
                                  TO_CHAR(NF.DTEMISSAO,'MMYYYY') AS DT_COMP_SERV,
                                  DECODE(NF.IDSTATUS, 'C',NF.DTCANCELANF, '') AS DT_CANC_NF,
                                  DECODE(PA.IDMOTCANCNF,'S', NF.IDMOTIVOCANCNF, '') AS MOT_CANC,
                                  DSMOTIVOCANCNF AS DS_CANC,
                                  '' AS NUM_NF_SUBS
                             FROM NOTAFISCAL NF, ITEMPROIMPOS IT, IMPOSTO II, ITEMPRODUTO IP, CLIENTE CL, ENDECLIE ED, MUNICIPIO MU,
                                  PAIS PS, MUNICIPIO MS, INSCRMUNICIP INS,
                                  PRODUTO PR, (SELECT IDEXIGISSQN, CDPRODSERV
                                                 FROM PARAMMUNISERV
                                                WHERE CDEMPRESA = P_CDEMPRESA
                                                  AND CDINSCMUNI = P_CDINSCMUNI
                                                  AND IDDECLARACAO = 'DS'
                                                  AND IDENTRSAIDOP = 'S') PSE, MODDOCFISCMUNI MO, PARAMMUNITPOPER PA, (SELECT DISTINCT I.CDFILIAL, I.NRLANCTONF
                                                                                                                         FROM IMPOSTONF I, MAPAAPURAC M
                                                                                                                        WHERE I.NRSEQUMAPAPU = M.NRSEQUMAPAPU
                                                                                                                          AND M.DTINIPERIODO = P_DTINICIAL
                                                                                                                          AND M.DTFIMPERIODO = P_DTFINAL
                                                                                                                          AND M.CDEMPRESA    = P_CDEMPRESA
                                                                                                                          AND M.CDINSCMUNI   = P_CDINSCMUNI
                                                                                                                          AND M.CDIMPOSTO    IN (V_ISSQN_S,V_ISSQN_RET_S)) IM
                            WHERE NF.CDFILIAL      = IT.CDFILIAL
                              AND NF.NRLANCTONF    = IT.NRLANCTONF
                              AND NF.CDSERIE       = PA.CDSERIENF
                              AND II.CDIMPOSTO     = IT.CDIMPOSTO
                              AND II.CDIMPOSTONFE  IN (V_ISSQN_S,V_ISSQN_RET_S)
                              AND NF.CDFILIAL      = IM.CDFILIAL
                              AND NF.NRLANCTONF    = IM.NRLANCTONF
                              AND NF.CDINSCMUNI    = P_CDINSCMUNI
                              AND NF.CDEMPRESA     = P_CDEMPRESA
                              AND IP.CDFILIAL      = IT.CDFILIAL
                              AND IP.NRLANCTONF    = IT.NRLANCTONF
                              AND IP.NRSEQITPROD   = IT.NRSEQITPROD
                              AND IP.CDPRODUTO     = PR.CDPRODUTO
                              AND MO.IDDECLARACAO  = 'DS'
                              AND MO.IDDECLARACAO  = PA.IDDECLARACAO
                              AND PA.CDEMPRESA     = P_CDEMPRESA
                              AND PA.CDINSCMUNI    = P_CDINSCMUNI
                              AND PA.IDENTRSAIDOP  = NF.IDENTRSAIDOP
                              AND PSE.CDPRODSERV(+)= PR.CDARVPROD
                              AND NF.IDENTRSAIDOP  = 'S'
                              AND PA.CDTIPOOPER    = NF.CDTIPOOPER
                              AND MO.CDMODDOCFISC  = PA.CDMODDOCMUNI
                              AND CL.CDCLIENTE     = NF.CDCLIENTE
                              AND CL.CDCLIENTE     = ED.CDCLIENTE
                              AND ED.CDMUNICIPIO   = MU.CDMUNICIPIO
                              AND ED.SGESTADO      = MU.SGESTADO
                              AND ED.CDPAIS        = PS.CDPAIS
                              AND MU.CDPAIS        = PS.CDPAIS
                              AND ED.IDTPENDECLIE  = 'P'
                              AND INS.CDINSCMUNI   = P_CDINSCMUNI
                              AND INS.CDEMPRESA    = P_CDEMPRESA
                              AND INS.CDMUNICIPIO  = MS.CDMUNICIPIO
                              AND INS.CDPAIS       = MS.CDPAIS
                              AND INS.SGESTADO     = MS.SGESTADO
                              AND PS.CDPAIS        = MS.CDPAIS
                            GROUP BY NF.DTEMISSAO,
                                  CLASSE_CODTRIBPROD(PR.CDARVPROD,NF.CDEMPRESA, NF.CDINSCMUNI),
                                  NF.CDINSCMUNI,
                                  MO.CDMODDOCFISC,
                                  DES_ISS_SERIE(P_CDEMPRESA, P_CDINSCMUNI, NF.CDSERIE),
                                  PSE.IDEXIGISSQN,
                                  MU.CDMUNICIBGE,
                                  DECODE(NF.IDSTATUS,'C', '0', DES_ISS_REG_ESP_TRIBUT(P_CDEMPRESA, P_CDINSCMUNI)),
                                  NF.NRNOTAFISC,
                                  NF.VRNOTAFISC,
                                  NF.VRPRODUTOS,
                                  DECODE(IT.CDFISCALIT, '1', IT.VRALIQITEM , 0),
                                  DECODE(NF.IDSTATUS,'A','1','C','2','3'),
                                  DECODE(V_CDSITUCRT, '3', '2',DECODE(DES_ISS_REG_ESP_TRIBUT(P_CDEMPRESA, P_CDINSCMUNI),'9','1','10','3','2')),
                                  DECODE(MU.CDMUNICIBGE, '3106200', NF.CDINSCMUNI, ''),
                                  DECODE(LENGTH(REPLACE(REPLACE(REPLACE(CL.NRINSJURCLIE,'-',''),'/',''),'.','')),14,CL.NRINSJURCLIE,' '),
                                  DECODE(LENGTH(REPLACE(REPLACE(REPLACE(CL.NRINSJURCLIE,'-',''),'/',''),'.','')),11,CL.NRINSJURCLIE,' '),
                                  NVL(CL.NMRAZSOCCLIE,'DIVERSOS'),
                                  ED.DSENDECLIE,
                                  ED.DSCOMPENDCLI,
                                  ED.NMBAIRCLIE,
                                  MU.CDMUNICIBGE,
                                  PS.CDPAISBACEN,
                                  DECODE(PS.CDPAISBACEN, '1058', ED.NRCEPCLIE, '' ),
                                  ED.NRTELECLIE,
                                  ED.DSEMAILCLIE,
                                  DECODE(PS.CDPAISBACEN, '1058', ED.NRCEPCLIE, '' ),
                                  TO_CHAR(NF.DTEMISSAO,'MMYYYY'),
                                  DECODE(NF.IDSTATUS, 'C',NF.DTCANCELANF, ''),
                                  DECODE(PA.IDMOTCANCNF,'S', NF.IDMOTIVOCANCNF, ''),
                                  DSMOTIVOCANCNF ))LOOP
      INSERT INTO ARQMAGNETICO
        (NRORDREGARQ, DSREGARQMAG, NRSEQARQMAG)
      VALUES
        ('02'||LPAD(RTRIM(V_CONTREGA), 8, '0'), C_ISS_E.REG_ISS_E , P_NRSEQARQMAG);
      V_CONTREGA := NVL(V_CONTREGA,0) + 1;
   END LOOP;
   RETURN V_REG_E;
END;
/

-- VERSAO --
BEGIN ATUVEROBJ('DES_ISS_BH_E','5.30.000'); END;
/
